<?php
/**
 * @file
 * faktura.rules_defaults.inc
 */

/**
 * Implements hook_default_rules_configuration().
 */
function faktura_default_rules_configuration() {
  $items = array();
  $items['rules_automatic_calculate_invoices_subtotal'] = entity_import('rules_config', '{ "rules_automatic_calculate_invoices_subtotal" : {
      "LABEL" : "Automatic calculate invoices subtotal",
      "PLUGIN" : "reaction rule",
      "TAGS" : [ "Invoice" ],
      "REQUIRES" : [ "rules" ],
      "ON" : [ "node_insert", "node_update" ],
      "IF" : [
        { "node_is_of_type" : {
            "node" : [ "node" ],
            "type" : { "value" : { "dunning" : "dunning", "invoice" : "invoice" } }
          }
        }
      ],
      "DO" : [
        { "variable_add" : {
            "USING" : { "type" : "decimal", "value" : "0" },
            "PROVIDE" : { "variable_added" : { "subtotal" : "Subtotal" } }
          }
        },
        { "LOOP" : {
            "USING" : { "list" : [ "node:field-invoice-item" ] },
            "ITEM" : { "list_item" : "Current invoice position" },
            "DO" : [
              { "data_calc" : {
                  "USING" : {
                    "input_1" : [ "subtotal" ],
                    "op" : "+",
                    "input_2" : [ "list-item:field-invoice-item-total" ]
                  },
                  "PROVIDE" : { "result" : { "result" : "Calculation result" } }
                }
              },
              { "data_set" : { "data" : [ "subtotal" ], "value" : [ "result" ] } }
            ]
          }
        },
        { "data_set" : { "data" : [ "node:field-invoice-subtotal" ], "value" : [ "subtotal" ] } },
        { "entity_save" : { "data" : [ "node" ] } }
      ]
    }
  }');
  $items['rules_automatic_calculate_invoices_total'] = entity_import('rules_config', '{ "rules_automatic_calculate_invoices_total" : {
      "LABEL" : "Automatic calculate invoices total",
      "PLUGIN" : "reaction rule",
      "WEIGHT" : "1",
      "TAGS" : [ "Invoice" ],
      "REQUIRES" : [ "rules" ],
      "ON" : [ "node_insert", "node_update" ],
      "IF" : [
        { "node_is_of_type" : {
            "node" : [ "node" ],
            "type" : { "value" : { "dunning" : "dunning", "invoice" : "invoice" } }
          }
        }
      ],
      "DO" : [
        { "variable_add" : {
            "USING" : { "type" : "decimal", "value" : [ "node:field-invoice-subtotal" ] },
            "PROVIDE" : { "variable_added" : { "total" : "Total" } }
          }
        },
        { "LOOP" : {
            "USING" : { "list" : [ "node:field-invoice-tax" ] },
            "ITEM" : { "tax_list_item" : "Current tax position" },
            "DO" : [
              { "data_calc" : {
                  "USING" : {
                    "input_1" : [ "total" ],
                    "op" : "+",
                    "input_2" : [ "tax-list-item:field-tax-amount" ]
                  },
                  "PROVIDE" : { "result" : { "result" : "Calculation result" } }
                }
              },
              { "data_set" : { "data" : [ "total" ], "value" : [ "result" ] } }
            ]
          }
        },
        { "entity_save" : { "data" : [ "node" ] } },
        { "data_set" : { "data" : [ "node:field-invoice-total" ], "value" : [ "total" ] } }
      ]
    }
  }');
  $items['rules_calculate_tax'] = entity_import('rules_config', '{ "rules_calculate_tax" : {
      "LABEL" : "Calculate tax",
      "PLUGIN" : "reaction rule",
      "WEIGHT" : "1",
      "ACTIVE" : false,
      "TAGS" : [ "Tax" ],
      "REQUIRES" : [ "rules" ],
      "ON" : [ "node_update" ],
      "IF" : [
        { "node_is_of_type" : { "node" : [ "node" ], "type" : { "value" : { "invoice" : "invoice" } } } }
      ],
      "DO" : [
        { "variable_add" : {
            "USING" : { "type" : "list\\u003Cfield_collection_item\\u003E", "value" : [ "" ] },
            "PROVIDE" : { "variable_added" : { "cleared_tax_list_variable_added" : "Cleared tax list" } }
          }
        },
        { "LOOP" : {
            "USING" : { "list" : [ "node:field-invoice-item" ] },
            "ITEM" : { "invoice_list_item" : "Current invoice item" },
            "DO" : [
              { "list_add" : {
                  "list" : [ "cleared-tax-list-variable-added" ],
                  "item" : [ "invoice-list-item" ],
                  "unique" : 1
                }
              }
            ]
          }
        },
        { "entity_save" : { "data" : [ "node" ] } }
      ]
    }
  }');
  $items['rules_get_time_report_values'] = entity_import('rules_config', '{ "rules_get_time_report_values" : {
      "LABEL" : "Get time report values",
      "PLUGIN" : "rule",
      "TAGS" : [ "Hourly wage invoice" ],
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : {
        "node" : { "label" : "Node", "type" : "node" },
        "hourly_wage" : { "label" : "Houry wage", "type" : "decimal", "parameter" : false },
        "quantity" : { "label" : "Quantity", "type" : "decimal", "parameter" : false },
        "tax" : { "label" : "Tax", "type" : "node", "parameter" : false },
        "customer" : { "label" : "Customer", "type" : "node", "parameter" : false }
      },
      "IF" : [
        { "entity_has_field" : { "entity" : [ "node" ], "field" : "field_hourly_wage" } },
        { "node_is_of_type" : {
            "node" : [ "node" ],
            "type" : { "value" : { "time_report" : "time_report" } }
          }
        }
      ],
      "DO" : [
        { "data_set" : { "data" : [ "hourly-wage" ], "value" : [ "node:field-hourly-wage" ] } },
        { "data_set" : { "data" : [ "quantity" ], "value" : [ "node:field-duration" ] } },
        { "data_set" : { "data" : [ "tax" ], "value" : [ "node:field-invoice-item-tax" ] } },
        { "data_set" : { "data" : [ "customer" ], "value" : [ "node:field-customer" ] } }
      ],
      "PROVIDES VARIABLES" : [ "hourly_wage", "quantity", "tax", "customer" ]
    }
  }');
  $items['rules_link_condition_odt_cloned'] = entity_import('rules_config', '{ "rules_link_condition_odt_cloned" : {
      "LABEL" : "Rules link: ODT Export condition",
      "PLUGIN" : "and",
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : { "node" : { "label" : "node", "type" : "node" } },
      "AND" : [
        { "AND" : [
            { "entity_has_field" : { "entity" : [ "node" ], "field" : "field_ref_company" } },
            { "entity_has_field" : {
                "entity" : [ "node:field-ref-company" ],
                "field" : "field_invoice_template"
              }
            },
            { "NOT data_is_empty" : { "data" : [ "node:field-ref-company:field-invoice-template" ] } }
          ]
        }
      ]
    }
  }');
  $items['rules_link_condition_pdf_export'] = entity_import('rules_config', '{ "rules_link_condition_pdf_export" : {
      "LABEL" : "Rules link: PDF Export condition",
      "PLUGIN" : "and",
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : { "node" : { "label" : "node", "type" : "node" } },
      "AND" : [
        { "AND" : [
            { "entity_has_field" : { "entity" : [ "node" ], "field" : "field_ref_company" } },
            { "entity_has_field" : {
                "entity" : [ "node:field-ref-company" ],
                "field" : "field_invoice_template"
              }
            },
            { "NOT data_is_empty" : { "data" : [ "node:field-ref-company:field-invoice-template" ] } }
          ]
        }
      ]
    }
  }');
  $items['rules_link_set_odt_cloned'] = entity_import('rules_config', '{ "rules_link_set_odt_cloned" : {
      "LABEL" : "Rules link: ODT Export rules set",
      "PLUGIN" : "rule set",
      "REQUIRES" : [ "rules", "php" ],
      "USES VARIABLES" : { "node" : { "type" : "node", "label" : "node" } },
      "RULES" : [
        { "RULE" : {
            "IF" : [
              { "entity_has_field" : { "entity" : [ "node" ], "field" : "field_ref_company" } },
              { "entity_has_field" : {
                  "entity" : [ "node:field-ref-company" ],
                  "field" : "field_invoice_template"
                }
              }
            ],
            "DO" : [
              { "php_eval" : { "code" : "faktura_document_export($node, \\u0027odt\\u0027);" } }
            ],
            "LABEL" : "ODT Export"
          }
        }
      ]
    }
  }');
  $items['rules_link_set_pdf_export'] = entity_import('rules_config', '{ "rules_link_set_pdf_export" : {
      "LABEL" : "Rules link: PDF Export rules set",
      "PLUGIN" : "rule set",
      "REQUIRES" : [ "rules", "php" ],
      "USES VARIABLES" : { "node" : { "label" : "node", "type" : "node" } },
      "RULES" : [
        { "RULE" : {
            "IF" : [
              { "entity_has_field" : { "entity" : [ "node" ], "field" : "field_ref_company" } },
              { "entity_has_field" : {
                  "entity" : [ "node:field-ref-company" ],
                  "field" : "field_invoice_template"
                }
              }
            ],
            "DO" : [
              { "php_eval" : { "code" : "faktura_document_export($node, \\u0027pdf\\u0027);" } }
            ],
            "LABEL" : "PDF Export"
          }
        }
      ]
    }
  }');
  $items['rules_prefill_invoice'] = entity_import('rules_config', '{ "rules_prefill_invoice" : {
      "LABEL" : "Prefill invoice",
      "PLUGIN" : "action set",
      "TAGS" : [ "Prefill invoice" ],
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : { "time_reports" : { "label" : "Time reports", "type" : "list\\u003Cnode\\u003E" } },
      "ACTION SET" : [
        { "entity_create" : {
            "USING" : {
              "type" : "node",
              "param_type" : "invoice",
              "param_title" : "RULES CREATED INVOICE",
              "param_author" : [ "site:current-user" ]
            },
            "PROVIDE" : { "entity_created" : { "invoice_created" : "Invoice" } }
          }
        },
        { "LOOP" : {
            "USING" : { "list" : [ "time-reports" ] },
            "ITEM" : { "current_time_report_list_item" : "Current time report" },
            "DO" : [
              { "component_rules_get_time_report_values" : {
                  "USING" : { "node" : [ "current-time-report-list-item" ] },
                  "PROVIDE" : {
                    "hourly_wage" : { "hourly_wage" : "Houry wage" },
                    "quantity" : { "quantity" : "Quantity" },
                    "tax" : { "tax" : "Tax" },
                    "customer" : { "customer" : "Customer" }
                  }
                }
              },
              { "entity_fetch" : {
                  "USING" : {
                    "type" : "node",
                    "id" : [ "current-time-report-list-item:nid" ],
                    "revision_id" : [ "" ]
                  },
                  "PROVIDE" : { "entity_fetched" : { "time_report_entity_fetched" : "Fetched time report entity" } }
                }
              },
              { "entity_create" : {
                  "USING" : {
                    "type" : "field_collection_item",
                    "param_field_name" : "field_invoice_item",
                    "param_host_entity" : [ "invoice-created" ]
                  },
                  "PROVIDE" : { "entity_created" : { "invoice_items_entity_created" : "Invoice items entity" } }
                }
              },
              { "drupal_message" : { "message" : [ "current-time-report-list-item:title" ] } },
              { "data_set" : {
                  "data" : [ "invoice-items-entity-created:field-invoice-item-desc" ],
                  "value" : [ "current-time-report-list-item:body:value" ]
                }
              },
              { "data_set" : {
                  "data" : [ "invoice-items-entity-created:field-invoice-item-unit-price" ],
                  "value" : [ "hourly-wage" ]
                }
              },
              { "data_set" : {
                  "data" : [ "invoice-items-entity-created:field-invoice-item-qty" ],
                  "value" : [ "quantity" ]
                }
              },
              { "data_calc" : {
                  "USING" : { "input_1" : [ "hourly-wage" ], "op" : "*", "input_2" : [ "quantity" ] },
                  "PROVIDE" : { "result" : { "result" : "Calculation result" } }
                }
              },
              { "data_set" : {
                  "data" : [ "invoice-items-entity-created:field-invoice-item-total" ],
                  "value" : [ "result" ]
                }
              },
              { "data_set" : {
                  "data" : [ "invoice-items-entity-created:field-invoice-item-tax" ],
                  "value" : [ "tax" ]
                }
              },
              { "data_set" : {
                  "data" : [ "invoice-created:field-customer" ],
                  "value" : [ "customer" ]
                }
              }
            ]
          }
        },
        { "entity_save" : { "data" : [ "invoice-created" ], "immediate" : 1 } },
        { "redirect" : { "url" : "invoices" } },
        { "component_rules_reference_time_report_to_created_invoice" : {
            "time_reports" : [ "time-reports" ],
            "created_invoice" : [ "invoice-created" ]
          }
        }
      ]
    }
  }');
  $items['rules_reference_time_report_to_created_invoice'] = entity_import('rules_config', '{ "rules_reference_time_report_to_created_invoice" : {
      "LABEL" : "Reference time report to created invoice",
      "PLUGIN" : "action set",
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : {
        "time_reports" : { "label" : "Time reports", "type" : "list\\u003Cnode\\u003E" },
        "created_invoice" : { "label" : "Created invoice", "type" : "node" }
      },
      "ACTION SET" : [
        { "LOOP" : {
            "USING" : { "list" : [ "time-reports" ] },
            "ITEM" : { "current_time_report_list_item" : "Current time report" },
            "DO" : [
              { "component_rules_set_time_report_status_to_invoiced_selected_invoice_" : {
                  "USING" : {
                    "time_report" : [ "current-time-report-list-item" ],
                    "created_invoice" : [ "created-invoice" ]
                  },
                  "PROVIDE" : { "time_report" : { "time_report_changed" : "Time report changed" } }
                }
              },
              { "entity_save" : { "data" : [ "time-report-changed" ] } }
            ]
          }
        }
      ]
    }
  }');
  $items['rules_set_time_report_status_to_invoiced_selected_invoice_'] = entity_import('rules_config', '{ "rules_set_time_report_status_to_invoiced_selected_invoice_" : {
      "LABEL" : "Set time report status to invoiced (selected invoice)",
      "PLUGIN" : "rule",
      "REQUIRES" : [ "rules" ],
      "USES VARIABLES" : {
        "time_report" : { "label" : "Time report", "type" : "node" },
        "created_invoice" : { "label" : "Created invoice", "type" : "node" }
      },
      "IF" : [
        { "node_is_of_type" : {
            "node" : [ "time-report" ],
            "type" : { "value" : { "time_report" : "time_report" } }
          }
        },
        { "node_is_of_type" : {
            "node" : [ "created-invoice" ],
            "type" : { "value" : { "invoice" : "invoice" } }
          }
        }
      ],
      "DO" : [
        { "data_set" : { "data" : [ "time-report:field-invoiced" ], "value" : 1 } },
        { "data_set" : {
            "data" : [ "time-report:field-invoice" ],
            "value" : [ "created-invoice" ]
          }
        }
      ],
      "PROVIDES VARIABLES" : [ "time_report" ]
    }
  }');
  return $items;
}
